Scala Standard Library2.13.5 < Back


# Packages

-  package root

  This is the documentation for the Scala standard library.

  This is the documentation for the Scala standard library.

  #### Package structure

  The scala package contains core types like `Int`, `Float`, `Array` or `Option` which are accessible in all Scala compilation units without explicit qualification or imports.

  Notable packages include:

  - `scala.collection` and its sub-packages contain Scala's collections framework
    - `scala.collection.immutable` - Immutable, sequential data-structures such as `Vector`, `List`, `Range`, `HashMap` or `HashSet`
    - `scala.collection.mutable` - Mutable, sequential data-structures such as `ArrayBuffer`, `StringBuilder`, `HashMap` or `HashSet`
    - `scala.collection.concurrent` - Mutable, concurrent data-structures such as `TrieMap`
  - `scala.concurrent` - Primitives for concurrent programming such as `Futures` and `Promises`
  - `scala.io` - Input and output operations
  - `scala.math` - Basic math functions and additional numeric types like `BigInt` and `BigDecimal`
  - `scala.sys` - Interaction with other processes and the operating system
  - `scala.util.matching` - Regular expressions

  Other packages exist. See the complete list on the right.

  Additional parts of the standard library are shipped as separate libraries. These include:

  - `scala.reflect` - Scala's reflection API (scala-reflect.jar)
  - `scala.xml` - XML parsing, manipulation, and serialization (scala-xml.jar)
  - `scala.collection.parallel` - Parallel collections (scala-parallel-collections.jar)
  - `scala.util.parsing` - Parser combinators (scala-parser-combinators.jar)
  - `scala.swing` - A convenient wrapper around Java's GUI framework called Swing (scala-swing.jar)

  #### Automatic imports

  Identifiers in the scala package and the `scala.Predef` object are always in scope by default.

  Some of these identifiers are type aliases provided as shortcuts to commonly used classes. For example, `List` is an alias for `scala.collection.immutable.List`.

  Other aliases refer to classes provided by the underlying platform. For example, on the JVM, `String` is an alias for `java.lang.String`.

  Definition Classes
    root
-  package scala

  Core Scala types.

  Core Scala types. They are always available without an explicit import.

  Definition Classes
    root
-  package math

  The package object `scala.math` contains methods for performing basic numeric operations such as elementary exponential, logarithmic, root and trigonometric functions.

  The package object `scala.math` contains methods for performing basic numeric operations such as elementary exponential, logarithmic, root and trigonometric functions.

  All methods forward to java.lang.Math unless otherwise noted.

  Definition Classes
    scala
  See also

    java.lang.Math

-  object BigDecimal extends java.io.Serializable
  Definition Classes
    math
- RoundingMode

o

scala.math.BigDecimal

# RoundingMode

###

#### object RoundingMode extends Enumeration

Source
  BigDecimal.scala

Linear Supertypes
Enumeration, java.io.Serializable, AnyRef, Any
Content Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. RoundingMode
2. Enumeration
3. Serializable
4. AnyRef
5. Any

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Type Members

1.  class Val extends Value with Serializable

   A class implementing the scala.Enumeration.Value type.

   A class implementing the scala.Enumeration.Value type. This class can be overridden to change the enumeration's naming and integer identification behaviour.

   Attributes
     protected
   Definition Classes
     Enumeration
   Annotations
     @SerialVersionUID()
2.  abstract class Value extends Ordered[Value] with Serializable

   The type of the enumerated values.

   The type of the enumerated values.

   Definition Classes
     Enumeration
   Annotations
     @SerialVersionUID()
3.  class ValueSet extends AbstractSet[Value] with SortedSet[Value] with SortedSetOps[Value, SortedSet, ValueSet] with StrictOptimizedIterableOps[Value, Set, ValueSet] with Serializable

   A class for sets of values.

   A class for sets of values. Iterating through this set will yield values in increasing order of their ids.

   Definition Classes
     Enumeration
   Annotations
     @SerialVersionUID()
4.  type RoundingMode = Value

### Value Members

1.  implicit object ValueOrdering extends Ordering[Value]

   An ordering by id for values of this set

   An ordering by id for values of this set

   Definition Classes
     Enumeration
2.  object ValueSet extends SpecificIterableFactory[Value, ValueSet] with java.io.Serializable

   A factory object for value sets

   A factory object for value sets

   Definition Classes
     Enumeration
   Annotations
     @SerialVersionUID()
3.  final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any
4.  final def ##: Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any
5.  final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any
6.  val CEILING: Value
7.  val DOWN: Value
8.  val FLOOR: Value
9.  val HALF_DOWN: Value
10.  val HALF_EVEN: Value
11.  val HALF_UP: Value
12.  val UNNECESSARY: Value
13.  val UP: Value
14.  final def Value(i: Int, name: String): Value

    Creates a fresh value, part of this enumeration, called `name` and identified by the integer `i`.

    Creates a fresh value, part of this enumeration, called `name` and identified by the integer `i`.

    i

      An integer that identifies this value at run-time. It must be unique amongst all values of the enumeration.

    name

      A human-readable name for that value.

    returns

      Fresh value with the provided identifier `i` and name `name`.

    Attributes
      protected
    Definition Classes
      Enumeration
15.  final def Value(name: String): Value

    Creates a fresh value, part of this enumeration, called `name`.

    Creates a fresh value, part of this enumeration, called `name`.

    name

      A human-readable name for that value.

    returns

      Fresh value called `name`.

    Attributes
      protected
    Definition Classes
      Enumeration
16.  final def Value(i: Int): Value

    Creates a fresh value, part of this enumeration, identified by the integer `i`.

    Creates a fresh value, part of this enumeration, identified by the integer `i`.

    i

      An integer that identifies this value at run-time. It must be unique amongst all values of the enumeration.

    returns

      Fresh value identified by `i`.

    Attributes
      protected
    Definition Classes
      Enumeration
17.  final def Value: Value

    Creates a fresh value, part of this enumeration.

    Creates a fresh value, part of this enumeration.

    Attributes
      protected
    Definition Classes
      Enumeration
18.  final def apply(x: Int): Value

    The value of this enumeration with given id `x`

    The value of this enumeration with given id `x`

    Definition Classes
      Enumeration
19.  final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

20.  def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
    Note

      not specified by SLS as a member of AnyRef

21.  final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
22.  def equals(arg0: AnyRef): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any
23.  def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
    Note

      not specified by SLS as a member of AnyRef

24.  final def getClass(): Class[_ <: AnyRef]

    Returns the runtime class representation of the object.

    Returns the runtime class representation of the object.

    returns

      a class object corresponding to the runtime type of the receiver.

    Definition Classes
      AnyRef → Any
    Annotations
      @native()
25.  def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
    Annotations
      @native()
26.  final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any
27.  final def maxId: Int

    The one higher than the highest integer amongst those used to identify values in this enumeration.

    The one higher than the highest integer amongst those used to identify values in this enumeration.

    Definition Classes
      Enumeration
28.  final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
29.  var nextId: Int

    The integer to use to identify the next created value.

    The integer to use to identify the next created value.

    Attributes
      protected
    Definition Classes
      Enumeration
30.  var nextName: Iterator[String]

    The string to use to name the next created value.

    The string to use to name the next created value.

    Attributes
      protected
    Definition Classes
      Enumeration
31.  final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @native()
    Note

      not specified by SLS as a member of AnyRef

32.  final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @native()
    Note

      not specified by SLS as a member of AnyRef

33.  def readResolve(): AnyRef
    Attributes
      protected
    Definition Classes
      Enumeration
34.  final def synchronized[T0](arg0: => T0): T0

    Executes the code in `body` with an exclusive lock on `this`.

    Executes the code in `body` with an exclusive lock on `this`.

    returns

      the result of `body`

    Definition Classes
      AnyRef
35.  def toString(): String

    The name of this enumeration.

    The name of this enumeration.

    returns

      a String representation of the object.

    Definition Classes
      Enumeration → AnyRef → Any
36.  def values: ValueSet

    The values of this enumeration as a set.

    The values of this enumeration as a set.

    Definition Classes
      Enumeration
37.  final def wait(): Unit

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait--.

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait--.

    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
    Note

      not specified by SLS as a member of AnyRef

38.  final def wait(arg0: Long, arg1: Int): Unit

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-int-

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-int-

    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
    Note

      not specified by SLS as a member of AnyRef

39.  final def wait(arg0: Long): Unit

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-.

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-.

    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()
    Note

      not specified by SLS as a member of AnyRef

40.  final def withName(s: String): Value

    Return a `Value` from this `Enumeration` whose name matches the argument `s`.

    Return a `Value` from this `Enumeration` whose name matches the argument `s`. The names are determined automatically via reflection.

    s

      an `Enumeration` name

    returns

      the `Value` of this `Enumeration` if its name matches `s`

    Definition Classes
      Enumeration
    Exceptions thrown

      `NoSuchElementException` if no `Value` with a matching name is in this `Enumeration`

### Inherited from Enumeration

### Inherited from java.io.Serializable

### Inherited from AnyRef

### Inherited from Any

### Ungrouped